hdu 2602 Bone Collector(01背包)

Bone Collector

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 42179    Accepted Submission(s): 17543


Problem Description
Many years ago , in Teddy’s hometown there was a man who was called “Bone Collector”. This man like to collect varies of bones , such as dog’s , cow’s , also he went to the grave …
The bone collector had a big bag with a volume of V ,and along his trip of collecting there are a lot of bones , obviously , different bone has different value and different volume, now given the each bone’s value along his trip , can you calculate out the maximum of the total value the bone collector can get ?
 

 

Input
The first line contain a integer T , the number of cases.
Followed by T cases , each case three lines , the first line contain two integer N , V, (N <= 1000 , V <= 1000 )representing the number of bones and the volume of his bag. And the second line contain N integers representing the value of each bone. The third line contain N integers representing the volume of each bone.
 

 

Output
One integer per line representing the maximum of the total value (this number will be less than 231).
 

 

Sample Input
1
5 10
1 2 3 4 5
5 4 3 2 1
 

 

Sample Output
14
 

 

Author
Teddy
 

 

Source
 

 

Recommend
lcy   |   We have carefully selected several similar problems for you:  2159 2955 1171 2844 1087 
 
很久之前就写过这道题,很久之前也接触过背包,写过很多01背包的题,但是就是记不住!貌似对所有的dp我都不能灵活的运用,因此感到非常懊恼。于是我决定把所以的背包题重新写一次。
最简单的背包题,模板01背包。
 
题意:第一行输入几组数据,第二行第一个数字代表物体个数,第二个数代表总体积。需要注意的是,第三排输入的是物品的价值,第四排的物品的体积。在不可以拆分物体的前提下,已知背包的总体积,最大能获取的价值是多少。
 
附上代码:
 
 1 #include <iostream>
 2 #include <cstdio>
 3 #include <cstring>
 4 using namespace std;
 5 int max(int a,int b)
 6 {
 7     return a>b?a:b;
 8 }
 9 int main()
10 {
11     int T,n,m,i,j;
12     int a[1005],b[1005];
13     scanf("%d",&T);
14     while(T--)
15     {
16         scanf("%d%d",&n,&m);
17         for(i=0; i<n; i++)    //输入价值
18             scanf("%d",&a[i]);
19         for(i=0; i<n; i++)   //输入体积
20             scanf("%d",&b[i]);
21         int dp[1005];  //dp数组始终记录当前体积的最大价值
22         memset(dp,0,sizeof(dp));  //dp全部初始化为0
23         for(i=0; i<n; i++)   //从第一个开始循环
24             for(j=m; j>=b[i]; j--)
25                 dp[j]=max(dp[j],dp[j-b[i]]+a[i]);  //比较放入i物体后的价值与不放之前的价值,记录大的值
26         printf("%d\n",dp[m]);   //输入总体积的最大价值
27     }
28     return 0;
29 }

 

posted @ 2015-11-28 19:55  lucky_少哖  阅读(728)  评论(0编辑  收藏  举报